<template>
  <div class="location-shoulder">
    <h2
      :class="[
        'location-shoulder__title',
        point.isMain && logchainModality !== 'e7519ee8-faf4-11e9-8f0b-362b9e155667' ? 'location-shoulder__title--main' : '',
      ]"
    >
      {{ point.from || 'Новая локация' }} → {{ point.address.label || point.locationTitle }}
      <span
        class="info"
        v-if="point.isMain && this.logchainModality !== 'e7519ee8-faf4-11e9-8f0b-362b9e155667'"
      >
        <i class="icon checked"></i>
        Определяющее плечо
      </span>
      <template v-if="!isMultistop">
        <span
          v-if="!point.isMain && !isPublished && canBeActive && this.logchainModality !== 'e7519ee8-faf4-11e9-8f0b-362b9e155667'"
          @click="$emit('onMakeActivePoint', point.ordinal)"
        >
          Сделать определяющим плечом
        </span>
        <span
          class="disabled"
          v-else-if="!point.isMain && !isPublished && !canBeActive && this.logchainModality !== 'e7519ee8-faf4-11e9-8f0b-362b9e155667'"
        >
          <obTooltip
            content="Нельзя сделать это плечо определяющим. Создайте новую логцепочку с нужной модальностью из соответствующей вкладки в браузере или черновиках."
            position="top-start"
          >
            <i class="icon alert"></i>
          </obTooltip>
          Сделать определяющим плечом
        </span>
      </template>

    </h2>
    <div class="logchain-shoulder__services" v-if="(!isPublished && !point.services.length && !isMultistop) || (!isPublished && !point.services.length && isMultistop && logchainModality === 'e7519b46-faf4-11e9-8f0b-362b9e155667' && point.ordinal === 2)">
      <p>
        <i class="icon info"></i>
        Добавьте услуги на плече
      </p>
      <ob-button
        label="Добавить услуги"
        @click="$emit('onAddServices', point.ordinal)"
      ></ob-button>
    </div>
    <div
      class="logchain-shoulder__services logchain-shoulder__services--published"
      v-if="point.services.length">
      <span @click="$emit('onAddServices', point.ordinal)">
        <i class="icon truck" />
        Добавлено услуг {{ point.services.length }}
      </span>
      <span v-if="isMultistop">
        <i class="icon checked"></i>
        Услуги зафиксированы для всех плеч. Логцепочка является мультистоповой
      </span>
    </div>
    <div
      class="add-between"
      @click="$emit('onAddPoint', prevOrdinal)"
      v-if="!isPublished && !isNotExpandable"
    >
      <i class="icon plus"></i>
      Добавить локацию <b>между</b> {{ point.from }} и {{ point.address.label }}
    </div>
  </div>
</template>

<script>
import ObButton from 'common-components/src/obComponents/obButton';
import obTooltip from 'common-components/src/obComponents/obTooltip';

export default {
  name: 'locationShoulder',

  props: {
    point: {
      type: Object,
      required: true
    },

    logchainModality: {
      type: String,
      required: true
    },

    isPublished: {
      type: Boolean,
      required: true
    },

    prevOrdinal: {
      type: Number,
      required: true
    },

    isMultistop: {
      type: Boolean,
      default: false
    }
  },

  components: {
    ObButton,
    obTooltip,
  },

  computed: {
    isNotExpandable() {
      return !this.isMultistop && this.logchainModality === 'e7519b46-faf4-11e9-8f0b-362b9e155667'
    },
    canBeActive() {
      if (this.logchainModality === 'e7519ee8-faf4-11e9-8f0b-362b9e155667') {
        return false;
      }
      return (!this.point.services.length || this.point.services.length && this.point.resourceClassUuid === this.logchainModality);
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.location-shoulder {
  padding-left: 12px;
  margin-top: 30px;
  margin-bottom: 34px;
}

.location-shoulder__title {
  display: flex;
  align-items: center;
  padding-left: 42px;
  @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);

  span:not(.ob-tooltip) {
    display: flex;
    align-items: center;
    margin-left: 12px;
    padding: 5px 17px 2px 7px;
    border: 2px solid $color-blue-navy-blue;
    border-radius: 20px;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue, 0.4px);
    cursor: pointer;

    i {
      margin-right: 7px;
      position: relative;
      top: -1px;
    }

    &.disabled {
      border-color: $gray-window;
      color: $gray-window;

      i {
        color: $gray-window;
      }
    }
  }

  &--main {
    @include font-mixin(20px, 28px, 600, $green-craiola, 0.4px);

    span:not(.ob-tooltip) {
      border-color: $color-green-light;
      @include font-mixin(16px, 20px, 400, $green-craiola, 0.4px);
      cursor: auto;
    }
  }
}

.logchain-shoulder__services {
  margin-top: 30px;
  padding-left: 42px;

  p {
    margin-bottom: 10px;
    @include font-mixin(16px, 20px, 400, $color-text-base, 0.4px);
  }

  i {
    color: $color-error;
  }

  &--published {
    display: flex;
    align-items: center;

    span {
      display: inline-flex;
      align-items: center;
      height: 40px;
      border-radius: 20px;
      padding: 0 30px 0 18px;
      border: 2px solid $color-blue-navy-blue;
      @include font-mixin(16px, 20px, 400, $color-blue-navy-blue, 0.4px);

      i {
        margin-right: 5px;
        color: $color-blue-navy-blue;
      }
    }

    span:nth-child(2) {
      margin-left: 20px;
      padding: 20px;
      height: 64px;
      display: inline-flex;
      align-items: center;
      border: none;
      border-radius: 0;
      background-color: rgb(230, 254, 249);
      @include font-mixin(14px, 20px, 400, $color-text-base, 0.4px);

      i {
        margin-right: 20px;
        font-size: 20px;
        color: $Green-700;
      }
    }
  }
}

.add-between {
  margin-top: 30px;
  padding: 5px 0;
  background: #fff;
  cursor: pointer;

  i {
    color: $color-grey-span;
  }
}
</style>
